{% extends 'template.html' %}

{% block title %}WRF Simulation Request{% endblock %}
{% block head %}
    <meta name="viewport" content="initial-scale=1.0, user-scalable=no" />
    <style type="text/css">
        #layout { position: absolute; bottom: 0px; width: 100%; height: 85%; border-top-style: solid; }
        #map_canvas { position: absolute; bottom:0px; left: 300px; right:0px; width: 100%; height: 100%; border-left-style: solid; }
        #pastRequests { position: absolute; bottom: 0px; width: 300px; height: 100%;}
        #logout {position:absolute; right:0px; top:0px;}
    </style>
    <script type="text/javascript">
        var map;

        function updatePastRequests(){
            var url = '/viewRequests/{{ user.pk }}/';

            $.ajax({
                url:url,
                ifModified:true,
                success:function(html){
                    $("#pastRequests").html(html);
                },
                error:function(){
                    $("#pastRequests").html("<a href='" + url + "'>View Past Requests</a>");
                }
            });

            // Delays 5 seconds before updating content again
            setTimeout(updatePastRequests, 5000);
        }

        // Adds the markers to the map for all of the latlngs that the user has already requested
        function addLatLngs_to_map(){
            var lat = 0;
            var lng = 0;
            var pk = 0;
            var title = "";
            var link = "";
            var latlng;
            var marker;

            // Grabs all the inputs and places it into data
            $(".latlng").each(function(i){
                lat = $(this).find("#lat").val();
                lng = $(this).find("#lng").val();
                pk  = $(this).find("#pk").val();

                title = $(this).find("#title").val();
                latlng = new google.maps.LatLng(lat, lng);
                link = '/viewKMZ/' + pk + "/";

                marker = new google.maps.Marker({
                    position: latlng,
                    title: title,
                    url: link
                });
                marker.setMap(map);

                // Makes Marker Clickable
                google.maps.event.addListener(marker, 'click', function(){
                    window.location.href = this.url;
                });
            });

        }

        function initialize() {

            var latlng = new google.maps.LatLng(40.07160929510595, -105.9405756939366);
            var myOptions = {
                zoom      : 10,
                center    : latlng,
                mapTypeId : google.maps.MapTypeId.HYBRID
            };
            map = new google.maps.Map(document.getElementById("map_canvas"),
                    myOptions);

            $(document).ajaxSend(function(event, xhr, settings) {
                function getCookie(name) {
                    var cookieValue = null;
                    if (document.cookie && document.cookie != '') {
                        var cookies = document.cookie.split(';');
                        for (var i = 0; i < cookies.length; i++) {
                            var cookie = jQuery.trim(cookies[i]);
                            // Does this cookie string begin with the name we want?
                            if (cookie.substring(0, name.length + 1) == (name + '=')) {
                                cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                                break;
                            }
                        }
                    }
                    return cookieValue;
                }
                function sameOrigin(url) {
                    // url could be relative or scheme relative or absolute
                    var host      = document.location.host; // host + port
                    var protocol  = document.location.protocol;
                    var sr_origin = '//' + host;
                    var origin    = protocol + sr_origin;
                    // Allow absolute or scheme relative URLs to same origin
                    return (url == origin || url.slice(0, origin.length + 1) == origin + '/') ||
                            (url == sr_origin || url.slice(0, sr_origin.length + 1) == sr_origin + '/') ||
                        // or any other URL that isn't scheme relative or absolute i.e relative.
                            !(/^(\/\/|http:|https:).*/.test(url));
                }
                function safeMethod(method) {
                    return (/^(GET|HEAD|OPTIONS|TRACE)$/.test(method));
                }

                if (!safeMethod(settings.type) && sameOrigin(settings.url)) {
                    xhr.setRequestHeader("X-CSRFToken", getCookie('csrftoken'));
                }
            });

            google.maps.event.addListener(map, 'click', function(event){
                var bounds    = map.getBounds();
                var southWest = bounds.getSouthWest();
                var northEast = bounds.getNorthEast();
                var dialog    = $("#dialog");

                $.ajax({
                    url: "regData/",
                    success: function(html){
                        dialog.html(html);
                        dialog.find("#id_centerLat").val((southWest.lat()+northEast.lat())/2);
                        dialog.find("#id_centerLon").val((southWest.lng()+northEast.lng())/2);
                        dialog.find("#id_ignLat").val(event.latLng.lat());
                        dialog.find("#id_ignLon").val(event.latLng.lng());

                    },
                    error: function(html){
                        alert("Error Code: " + html);
                    }
                });

                dialog.dialog({
                    "title":"Simulator Input",
                    "width":450,
                    "buttons":{
                        "Submit":function(){
                            var data={};

                            // Grabs all the inputs and places it into data
                            dialog.find(':input')
                                .each(function(i){
                                        data[this.name] = this.value;
                                    });
                            $.ajax({
                                type:'POST',
                                url:'/regData/',
                                data: data,
                                success:function(html){
                                    // Used to compare to see if data valid
                                    var title = $("#dialog").find("title").html();

                                    $("#dialog").html(html);

                                    if($("#dialog").find("title").html() != title){
                                        var pk = $("#location").find("#pk").val();
                                        var link = "/viewKMZ/" + pk + "/";
                                        var marker = new google.maps.Marker({
                                            position: event.latLng,
                                            title: data['title'],
                                            url: link
                                        });
                                        marker.setMap(map);

                                        // Makes Marker Clickable
                                        google.maps.event.addListener(marker, 'click', function(){
                                            window.location.href = this.url;
                                        });

                                        $("#dialog").dialog('option', 'buttons', {'Close':function(){$("#dialog").dialog("close")}});
                                    }
                                },
                                error:function(){
                                    alert("ERROR:  CSRF Token might be incorrect.");
                                }
                            });
                        },
                        "Cancel":function(){
                            $("#dialog").dialog("close");
                        }
                    }
                });
            });

            // Updates all of the past requests onto the map
            updatePastRequests();
            addLatLngs_to_map();
        }

    </script>
{% endblock %}
{% block onload %}initialize(){% endblock %}
{% block content %}
    Click on a position on the map to start a wildfire simulation.
    <div id="layout">
        <div id="pastRequests">Loading</div>
        <div id="map_canvas"></div>
    </div>
    <div id="logout">{{ user.email }} (<a href="/accounts/logout/">Logout</a>)</div>
    <div id="dialog"></div>

    {% for location in locations %}
        <div class="latlng">
            <input type="hidden" id="pk" value="{{ location.pk }}" />
            <input type="hidden" id="lat" value="{{ location.ignLat }}" />
            <input type="hidden" id="lng" value="{{ location.ignLon }}" />
            <input type="hidden" id="title" value="{{ location.title }}" />
        </div>
    {% endfor %}
{% endblock %}

